<script lang="ts">

  //form
  import { formula } from 'svelte-formula'

  const messages = {
    username: {
      valueMissing: 'You really should enter a username'
    }
  }

  const validators = {
    username: {
        inDomain: (value: string|string[]) => value.includes('@svelte.dev') ? null : 'You can only sign up with a @svelte.dev email'
    }
  }

  const formValidators = {
    passwordsMatch: (values: { password: any; passwordMatch: any; }) => values.password === values.passwordMatch ? null : 'Passwords Must Match'
  }

  const { form, formValues, submitValues, formValidity, validity, touched, dirty, isFormValid } = formula({
    messages,
    validators,
    formValidators,
  });

  $: console.log('submit', $submitValues);
  $: console.log('current', $formValues);
  $: console.log('validity', $validity);
  $: console.log('touched', $touched);
  $: console.log('dirty', $dirty);
  $: console.log('form valid', $isFormValid);

  let imgDisplay: HTMLImageElement;

  $: formValues.subscribe((v: { file: any; }) => {
    if (v.file instanceof FileList) {
      for(const file of v.file) {
        imgDisplay = document.createElement('img');
        imgDisplay.src = URL.createObjectURL(file);
      }
    }
  })

  function handleSubmit(e: { preventDefault: () => void; }) {
    e.preventDefault();
  }
  // END form

</script>

<h1>Form Test</h1>

<div class="my-form">
  <div style="margin-bottom: 50px;">
    Open the console to see all value results
  </div>
  <hr />
  <form use:form on:submit={handleSubmit}>
      <div style="margin-top: 40px;" class='form-field'>
          <label for='username'>Username</label>
          <input type='email' id='username' name='username' required class:error={$touched?.username && $validity?.username?.invalid} aria-invalid={$validity?.username?.invalid} aria-describedBy="username-error"/>
          <div id="username-error" hidden={$validity?.username?.valid}>{$validity?.username?.message}</div>
      </div>

      <div class='form-field'>
          <label for='password'>Password</label>
          <input type='password' id='password' name='password' required minlength="8" class:error={$touched?.password && $validity?.password?.invalid} data-too-short="Your password is quite short I see"  aria-invalid={$validity?.password?.invalid} aria-describedBy="password-error"/>
          <div style="margin-bottom: 30px;" id="password-error" hidden={$validity?.password?.valid}>{$validity?.password?.message}</div>

          <label for='passwordMatch'>Password Match</label>
          <input type='password' id='passwordMatch' name='passwordMatch' required minlength="8" class:error={$touched?.passwordMatch && $validity?.passwordMatch?.invalid} data-too-short="Do you really want it this short?"  aria-invalid={$validity?.passwordMatch?.invalid} aria-describedBy="passwordMatch-error"/>
          <div id="passwordMatch-error" hidden={$validity?.passwordMatch?.valid}>{$validity?.passwordMatch?.message}</div>
          <br />
          <div hidden={!$formValidity?.passwordsMatch}>{$formValidity?.passwordsMatch}</div>
      </div>

      <div class='form-field'>
          <label for='text1'>Multiple Text 1</label>
          <input type='text' id='text1' name='same-text'/>
          <label for='text2'>Multiple Text 2</label>
          <input type='text' id='text2' name='same-text'/>
      </div>

      <div class='form-field'>
          <label for='number'>Enter a random Number</label>
          <input type='number' id='number' name='number'/>
      </div>

      <div class='form-field'>
          <label for='range'>Range</label>
          <input type='range' id='range' name='range' min="0" max="100" step="1"/>
          <label for='range1'>Range</label>
          <input type='range' id='range1' name='range' min="0" max="100" step="2"/>
      </div>

      <div class='form-field'>
          <label for='file'>File</label>
          <input type='file' id='file' name='file' accept=".jpg, .jpeg, .png"/>
          <!-- svelte-ignore a11y-img-redundant-alt -->
          <img alt="A magic image will appear here" hidden={!imgDisplay?.src} src={imgDisplay?.src} />
      </div>

      <div class='form-field'>
          <label for='date'>Date</label>
          <input type='date' id='date' name='date' />
      </div>

      <div class='form-field'>
          <label for='color'>Color</label>
          <input type='color' id='color' name='color' />
      </div>

      <div class='form-field'>
          <label for='url'>Enter a URL</label>
          <input type='url' id='url' name='url' class:error={$touched?.url && $validity?.url?.invalid}/>
          <div hidden={$validity?.url?.valid}>{$validity?.url?.message}</div>
      </div>

      <div class='form-field'>
          <label for='subscribe'>Subscribe To Our Newsletter</label>
          <input type='checkbox' id='subscribe' name='subscribe'/>
      </div>

      <div class='form-field'>
          <span>Select Animal</span>
          <label for='dog'>Dog</label>
          <input type='checkbox' id='dog' name='animal' value="Dog"/>
          <label for='cat'>Cat</label>
          <input type='checkbox' id='cat' name='animal' value="Cat"/>
          <label for='bird'>Bird</label>
          <input type='checkbox' id='bird' name='animal' value="Bird"/>
      </div>

      <div class='form-field'>
          <label for='select-me'>Select only one of me</label>
          <select id="select-me" name="select-me">
              <option value="" disabled>Select Option</option>
              <option value="a">A</option>
              <option value="b">B</option>
              <option value="c">C</option>
          </select>
      </div>

      <div class='form-field'>
          <label for='select-me-multi'>Select Multple of me!</label>
          <select id="select-me-multi" name="select-me-multi" multiple>
              <option value="" disabled>Select Option</option>
              <option value="a">A</option>
              <option value="b">B</option>
              <option value="c">C</option>
          </select>
      </div>

      <div class='form-field'>
          <span>Remember Me?</span>
          <label for='remember-yes'>Yes</label>
          <input type='radio' id='remember-yes' name='remember-me' value="yes" required/>
          <label for='remember-no'>No</label>
          <input type='radio' id='remember-no' name='remember-me' value="no" required/>
      </div>

      <button disabled={!$isFormValid}>Save</button>
  </form>
</div>

<style lang="scss">

  $radius: 5px;

  .my-form {
      padding-top: 3rem;
  }

  .form-field {
      margin-bottom: 50px;
      border-bottom: 1px solid lightgrey;
  }

  label {
    display: block;
  }

  .error {
    border: 1px solid red;
  }

</style>
